/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor.util;

import com.incquerylabs.emdw.valuedescriptor.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage
 * @generated
 */
public class ValuedescriptorAdapterFactory extends AdapterFactoryImpl {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ValuedescriptorPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValuedescriptorAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = ValuedescriptorPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValuedescriptorSwitch<Adapter> modelSwitch =
		new ValuedescriptorSwitch<Adapter>() {
			@Override
			public Adapter caseValueDescriptor(ValueDescriptor object) {
				return createValueDescriptorAdapter();
			}
			@Override
			public Adapter caseLiteralDescriptor(LiteralDescriptor object) {
				return createLiteralDescriptorAdapter();
			}
			@Override
			public Adapter caseVariableDescriptor(VariableDescriptor object) {
				return createVariableDescriptorAdapter();
			}
			@Override
			public Adapter caseOperationCallDescriptor(OperationCallDescriptor object) {
				return createOperationCallDescriptorAdapter();
			}
			@Override
			public Adapter caseSingleVariableDescriptor(SingleVariableDescriptor object) {
				return createSingleVariableDescriptorAdapter();
			}
			@Override
			public Adapter caseCollectionVariableDescriptor(CollectionVariableDescriptor object) {
				return createCollectionVariableDescriptorAdapter();
			}
			@Override
			public Adapter casePropertyAccessDescriptor(PropertyAccessDescriptor object) {
				return createPropertyAccessDescriptorAdapter();
			}
			@Override
			public Adapter casePropertyReadDescriptor(PropertyReadDescriptor object) {
				return createPropertyReadDescriptorAdapter();
			}
			@Override
			public Adapter casePropertyWriteDescriptor(PropertyWriteDescriptor object) {
				return createPropertyWriteDescriptorAdapter();
			}
			@Override
			public Adapter caseParameterDescriptor(ParameterDescriptor object) {
				return createParameterDescriptorAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor <em>Value Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor
	 * @generated
	 */
	public Adapter createValueDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.LiteralDescriptor <em>Literal Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.LiteralDescriptor
	 * @generated
	 */
	public Adapter createLiteralDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.VariableDescriptor <em>Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.VariableDescriptor
	 * @generated
	 */
	public Adapter createVariableDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.OperationCallDescriptor <em>Operation Call Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.OperationCallDescriptor
	 * @generated
	 */
	public Adapter createOperationCallDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.SingleVariableDescriptor <em>Single Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.SingleVariableDescriptor
	 * @generated
	 */
	public Adapter createSingleVariableDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor <em>Collection Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor
	 * @generated
	 */
	public Adapter createCollectionVariableDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyAccessDescriptor <em>Property Access Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyAccessDescriptor
	 * @generated
	 */
	public Adapter createPropertyAccessDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyReadDescriptor <em>Property Read Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyReadDescriptor
	 * @generated
	 */
	public Adapter createPropertyReadDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyWriteDescriptor <em>Property Write Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyWriteDescriptor
	 * @generated
	 */
	public Adapter createPropertyWriteDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.incquerylabs.emdw.valuedescriptor.ParameterDescriptor <em>Parameter Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.incquerylabs.emdw.valuedescriptor.ParameterDescriptor
	 * @generated
	 */
	public Adapter createParameterDescriptorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //ValuedescriptorAdapterFactory
