/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor.util;

import com.incquerylabs.emdw.valuedescriptor.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage
 * @generated
 */
public class ValuedescriptorSwitch<T> extends Switch<T> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ValuedescriptorPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValuedescriptorSwitch() {
		if (modelPackage == null) {
			modelPackage = ValuedescriptorPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case ValuedescriptorPackage.VALUE_DESCRIPTOR: {
				ValueDescriptor valueDescriptor = (ValueDescriptor)theEObject;
				T result = caseValueDescriptor(valueDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.LITERAL_DESCRIPTOR: {
				LiteralDescriptor literalDescriptor = (LiteralDescriptor)theEObject;
				T result = caseLiteralDescriptor(literalDescriptor);
				if (result == null) result = caseValueDescriptor(literalDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.VARIABLE_DESCRIPTOR: {
				VariableDescriptor variableDescriptor = (VariableDescriptor)theEObject;
				T result = caseVariableDescriptor(variableDescriptor);
				if (result == null) result = caseValueDescriptor(variableDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.OPERATION_CALL_DESCRIPTOR: {
				OperationCallDescriptor operationCallDescriptor = (OperationCallDescriptor)theEObject;
				T result = caseOperationCallDescriptor(operationCallDescriptor);
				if (result == null) result = caseValueDescriptor(operationCallDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.SINGLE_VARIABLE_DESCRIPTOR: {
				SingleVariableDescriptor singleVariableDescriptor = (SingleVariableDescriptor)theEObject;
				T result = caseSingleVariableDescriptor(singleVariableDescriptor);
				if (result == null) result = caseVariableDescriptor(singleVariableDescriptor);
				if (result == null) result = caseValueDescriptor(singleVariableDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.COLLECTION_VARIABLE_DESCRIPTOR: {
				CollectionVariableDescriptor collectionVariableDescriptor = (CollectionVariableDescriptor)theEObject;
				T result = caseCollectionVariableDescriptor(collectionVariableDescriptor);
				if (result == null) result = caseVariableDescriptor(collectionVariableDescriptor);
				if (result == null) result = caseValueDescriptor(collectionVariableDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.PROPERTY_ACCESS_DESCRIPTOR: {
				PropertyAccessDescriptor propertyAccessDescriptor = (PropertyAccessDescriptor)theEObject;
				T result = casePropertyAccessDescriptor(propertyAccessDescriptor);
				if (result == null) result = caseValueDescriptor(propertyAccessDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.PROPERTY_READ_DESCRIPTOR: {
				PropertyReadDescriptor propertyReadDescriptor = (PropertyReadDescriptor)theEObject;
				T result = casePropertyReadDescriptor(propertyReadDescriptor);
				if (result == null) result = casePropertyAccessDescriptor(propertyReadDescriptor);
				if (result == null) result = caseValueDescriptor(propertyReadDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.PROPERTY_WRITE_DESCRIPTOR: {
				PropertyWriteDescriptor propertyWriteDescriptor = (PropertyWriteDescriptor)theEObject;
				T result = casePropertyWriteDescriptor(propertyWriteDescriptor);
				if (result == null) result = casePropertyAccessDescriptor(propertyWriteDescriptor);
				if (result == null) result = caseValueDescriptor(propertyWriteDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ValuedescriptorPackage.PARAMETER_DESCRIPTOR: {
				ParameterDescriptor parameterDescriptor = (ParameterDescriptor)theEObject;
				T result = caseParameterDescriptor(parameterDescriptor);
				if (result == null) result = caseVariableDescriptor(parameterDescriptor);
				if (result == null) result = caseValueDescriptor(parameterDescriptor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Value Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Value Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseValueDescriptor(ValueDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Literal Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Literal Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLiteralDescriptor(LiteralDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Variable Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Variable Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariableDescriptor(VariableDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Operation Call Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Operation Call Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOperationCallDescriptor(OperationCallDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Single Variable Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Single Variable Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSingleVariableDescriptor(SingleVariableDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Collection Variable Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Collection Variable Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCollectionVariableDescriptor(CollectionVariableDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Access Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Access Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyAccessDescriptor(PropertyAccessDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Read Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Read Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyReadDescriptor(PropertyReadDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Write Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Write Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyWriteDescriptor(PropertyWriteDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Parameter Descriptor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Parameter Descriptor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseParameterDescriptor(ParameterDescriptor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //ValuedescriptorSwitch
